/***********************************************
* conf.c - Read in the configuration file
* 
* CVS $Id: conf.c,v 1.11 2002/01/11 17:13:12 wcampbel Exp $
***********************************************/

#include "oper.h"

void strip(char *line)
{
	char *c;

	if ((c = strchr(line, '\n')))	*c = '\0';
	if ((c = strchr(line, '\r')))	*c = '\0';
}

void SetDefaults()
{
	me.port = 6667;
	memcpy(me.uplink, "127.0.0.1", sizeof(me.uplink));
	me.use_vhost = 0;
	memcpy(me.vhost, "127.0.0.1", sizeof(me.vhost));
	memcpy(me.desc, "Oper's OPER Bot", sizeof(me.desc));
	me.r_time = 10;
	memcpy(me.nick, "OperBot", sizeof(me.nick));
	memcpy(me.join_chan, "#admin", sizeof(me.join_chan));
	memcpy(me.op_chan, "#admin", sizeof(me.op_chan));
	memcpy(me.adpass, "password", sizeof(me.adpass));
	memcpy(me.connpass, "", sizeof(me.connpass));
}

void LoadConf()
{
	FILE *fp;
	char buf[BUFSIZE];
	char *s;

	if ((fp = fopen(CONFFILE, "r")) == NULL) {
		printf("Unable to open configuration file (%s)\n", CONFFILE);
		exit(0);
	}


	while (fgets(buf, BUFSIZE, fp)) {
		if (buf[0] == '#') {
			continue;
		}
		s = strtok(buf, " ");
		if (!strcmp(s, "SERVER_PORT")) {
			s = strtok(NULL, "\n");
			me.port = atoi(s);
		} else if (!strcmp(s, "CONNECT_TO")) {
			s = strtok(NULL, "\n");
			strip(s);
			memcpy(me.uplink, s, sizeof(me.uplink));
		} else if (!strcmp(s, "CONNECT_PASS")) {
			s = strtok(NULL, "\n");
			strip(s);
			memcpy(me.connpass, s, sizeof(me.connpass));
                } else if (!strncmp(s, "USE_VHOST", 9)) {
                        me.use_vhost = 1;
                } else if (!strcmp(s, "VHOST")) {
                        s = strtok(NULL, "\n");
                        strip(s);
                        memcpy(me.vhost, s, sizeof(me.vhost));
		} else if (!strcmp(s, "REALNAME")) {
			s = strtok(NULL, "\n");
			strip(s);
			memcpy(me.desc, s, sizeof(me.desc));
		} else if (!strcmp(s, "RECONNECT_TIME")) {
			s = strtok(NULL, "\n");
			me.r_time = atoi(s);
		} else if (!strcmp(s, "NICK")) {
			s = strtok(NULL, "\n");
			strip(s);
			memcpy(me.nick, s, sizeof(me.nick));
		} else if (!strcmp(s, "JOIN_CHANNEL")) {
			s = strtok(NULL, "\n");
			strip(s);
			memcpy(me.join_chan, s, sizeof(me.join_chan));
		} else if (!strcmp(s, "OP_CHANNEL")) {
			s = strtok(NULL, "\n");
			strip(s);
			memcpy(me.op_chan, s, sizeof(me.op_chan));
		} else if (!strcmp(s, "ADMINPASS")) {
			s = strtok(NULL, "\n");
			strip(s);
			memcpy(me.adpass, s, sizeof(me.adpass));
		}
	}
	fclose(fp);
}

char ** ParseChan(char * chanlist)
{
   char **c;
   char *st;
   int i;
   int j = 0;
   c = calloc(MAXCHAN + 1, sizeof(char *));
   for (i = 0; i < MAXCHAN + 1; i++)
	c[i] = NULL;
   if (chanlist) {
        for (st = strtok(chanlist, ",");
             st;
             st = strtok(NULL, ",")) {
		c[j] = strdup(st);
		j++;
		if (j == MAXCHAN) 
		    break;
	}
    }

    return c;
}
