/*****************************************
* irc.c - IRC related subroutines
*
* CVS $Id: irc.c,v 1.29 2002/09/25 01:29:43 wcampbel Exp $
*****************************************/

#include "oper.h"

void Register()
{
	if (me.connpass[0])
		sts("PASS %s", me.connpass);
	sts("USER oper 0 0 :%s", me.desc);
	sts("NICK %s", me.nick);
	op_flag = inv_flag = 0;
}

void Parse(char * buf)
{
        char *origin, *cmd, *coreLine;
        int cmdptr = 0;

        strip(buf);

        if (!(*buf))
                return;

        coreLine = strdup(buf);

#ifdef DEBUG
        log("R: %s", buf);
#endif
        origin = strtok(buf, " ");
        if (*origin == ':')
                cmdptr = 1;
        cmd = strtok(NULL, " ");

        if (cmdptr) {
                origin++;
		if (!strcmp(cmd, "PING")) {
			cmd = strtok(NULL, " ");
			sts("PONG :%s ", cmd);
		} else if (!strcmp(cmd, "001")) {
			int i;
			for (i=0; me.j_chanlist[i]; i++)
			    sts("JOIN %s", me.j_chanlist[i]);
		} else if (!strcmp(cmd, "INVITE")) {
			int i;
			cmd = strtok(NULL, " ");
			cmd = strtok(NULL, " ");
			cmd++;
			for (i=0; me.o_chanlist[i]; i++) {
				if (!strcasecmp(cmd, me.o_chanlist[i])) {
					sts("JOIN %s", me.o_chanlist[i]);
					break;
				}
			}
		} else if (!strcmp(cmd, "484")) {
                	sts("QUIT :OperBot Cannot Function in Restricted Mode");
                	sleep(1);
                	close(servsock);
                	exit(0);
		} else if (!strcmp(cmd, "710")) {
			/* H7 KNOCK numeric */
			char *who = strtok(NULL, " ");
			who = strtok(NULL, " ");
                        who = strtok(NULL, "!");
			inv_flag = 1;
#ifdef ALLOW_LOCAL_OPERS
			sts("WHOIS %s %s", who, who);
#else
                        sts("WHO %s", who);
#endif
		} else if (!strcmp(cmd, "352")) {
			char* who = NULL;
			char* vrai = NULL;
			cmd = strtok(NULL, " ");
			cmd = strtok(NULL, " ");
			cmd = strtok(NULL, " ");
                        cmd = strtok(NULL, " ");
                        cmd = strtok(NULL, " ");
                        who = strtok(NULL, " ");
                        cmd = strtok(NULL, " ");
			vrai = strchr(cmd, '*');
			if (vrai) {
				if (inv_flag) {
				    int i;
				    for (i = 0; me.o_chanlist[i]; i++)
					sts("INVITE %s %s", who, 
					    me.o_chanlist[i]);
				    inv_flag = 0;
				}
				if (op_flag) {
				    int i;
				    for (i = 0; me.o_chanlist[i]; i++)
					sts("MODE %s +o %s", me.o_chanlist[i],
					    who);
				    op_flag = 0;
				}
			}
		} else if (!strcmp(cmd, "313")) {
			char *who = strtok(NULL, " ");
			who = strtok(NULL, " ");
                        if (inv_flag) {
                            int i;
                            for (i = 0; me.o_chanlist[i]; i++)
                                sts("INVITE %s %s", who,
                                    me.o_chanlist[i]);
                            inv_flag = 0;
                        }
                        if (op_flag) {
                            int i;
                            for (i = 0; me.o_chanlist[i]; i++)
                                sts("MODE %s +o %s", me.o_chanlist[i],
                                    who);
                            op_flag = 0;
                        }
		} else if (!strcmp(cmd, "NOTICE")) {
			char * target = strtok(NULL, " ");
			char * cmd  = strtok(NULL, " ");
			char * nick = strtok(origin, "!");
			/* Note that supporting +channel's is useless */
                        if ((target[0] == '#') || (target[0] == '&') ||
                            (target[0] == '!')) {
                                /* Support KNOCK in H6 and early H7 */
                                if (!strcasecmp(cmd, ":KNOCK:")) {
                                        inv_flag = 1;
#ifdef ALLOW_LOCAL_OPERS
					sts("WHOIS %s %s", nick, nick);
#else
                                        sts("WHO %s", nick);
#endif
                                }
			} else {
				/* Support KNOCK in H6 and early H7 */
                                if (!strcasecmp(cmd, ":KNOCK:")) {
                                        inv_flag = 1;
#ifdef ALLOW_LOCAL_OPERS
					sts("WHOIS %s %s", nick, nick);
#else
                                        sts("WHO %s", nick);
#endif
				}
			}
		} else if (!strcmp(cmd, "PRIVMSG")) {
			char * target = strtok(NULL, " ");
			char * cmd = strtok(NULL, " ");
			char * p = strtok(NULL, "\n");
			char * nick = strtok(origin, "!");
			cmd++;
                        /* Note that supporting +channel's is useless */
			if ((target[0] == '#') || (target[0] == '&') ||
                            (target[0] == '!')) {
                                if (!strcasecmp(cmd, "\001PING")) {
				    if (p) {
                                        sts("NOTICE %s :\001PING %s",
                                                nick, p);
				    }
                                } else if (!strcasecmp(cmd, "\001CLIENTINFO\001")) {
                                        sts("NOTICE %s :\001CLIENTINFO OP INVITE PING CLIENTINFO VERSION\001", nick);
                                } else if (!strcasecmp(cmd, "\001VERSION\001")) {
                                        sts("NOTICE %s :\001VERSION %s\001",
                                                nick, me.version);
                                } else if (!strcasecmp(cmd, "\001OP\001")) {
                                        op_flag = 1;
#ifdef ALLOW_LOCAL_OPERS
					sts("WHOIS %s %s", nick, nick);
#else
                                        sts("WHO %s", nick);
#endif
                                }
			} else {
				if (!strcasecmp(cmd, "die")) {
					Shutdown(nick, p);
				} else if (!strcasecmp(cmd, "restart")) {
					Restart(nick, p);
				} else if (!strcasecmp(cmd, "shutdown")) {
					Shutdown(nick, p);
				} else if (!strcasecmp(cmd, "help")) {
					PrintHelp(nick, p);
				} else if (!strcasecmp(cmd, "\001PING")) {
				    if (p) {
					sts("NOTICE %s :\001PING %s",
						nick, p);
				    }
				} else if (!strcasecmp(cmd, "\001OP\001")) {
					op_flag = 1;
#ifdef ALLOW_LOCAL_OPERS
					sts("WHOIS %s %s", nick, nick);
#else
					sts("WHO %s", nick);
#endif
				} else if (!strcasecmp(cmd, "\001INVITE\001")) {
					inv_flag = 1;
#ifdef ALLOW_LOCAL_OPERS
					sts("WHOIS %s %s", nick, nick);
#else
					sts("WHO %s", nick);
#endif
				} else if (!strcasecmp(cmd, "\001CLIENTINFO\001")) {
					sts("NOTICE %s :\001CLIENTINFO OP INVITE PING CLIENTINFO VERSION\001", nick);
				} else if (!strcasecmp(cmd, "\001VERSION\001")) {
					sts("NOTICE %s :\001VERSION %s\001",
						nick, me.version);
				}
			}
		}
	} else {
		if (!strcmp(origin, "PING")) {
                        sts("PONG %s", cmd);
		}
	}

	free(coreLine);
}

void Shutdown(char* target, char* pass)
{
    if (pass) {
	if (!strcmp(pass, me.adpass)) {
		sts("QUIT :Shutdown by %s", target);
		sleep(1);
		close(servsock);
		exit(0);
	}
    }
    sts("PRIVMSG %s :Incorrect Password", target);
}

void Restart(char * target, char * pass)
{
    if (pass) {
	if (!strcmp(pass, me.adpass)) {
                sts("QUIT :Restart by %s", target);
		sleep(1);
                close(servsock);
/* Attempt to fix the rejected hold for rapidly reconnecting clients */
		sleep(1);
		execv(SPATH, NULL);
	}
    }
    sts("PRIVMSG %s :Incorrect Password", target);
}

void PrintHelp(char * target, char * cmd)
{
	if (cmd) {
		if (!strcasecmp(cmd, "shutdown")) {
			sts("PRIVMSG %s :Shuts down the service (syntax: shutdown <password>)",
				target);
		} else if (!strcasecmp(cmd, "die")) {
			sts("PRIVMSG %s :Shuts down the service (syntax: die <password>)",
				target);
		} else if (!strcasecmp(cmd, "restart")) {
			sts("PRIVMSG %s :Restarts the service (syntax: restart <password>)",
				target);
		}
	} else {
		sts("PRIVMSG %s :Commands:  shutdown, die, restart, help",
		target);
	}
}
