/**********************************************
* main.c - The main system file for SplitServ.
*          Ties all the other pieces together
*
* CVS $Id: main.c,v 1.6 2001/01/18 14:25:46 wcampbel Exp $
**********************************************/

#include "oper.h"
#include "patchlevel.h"

int main(int argc, char *argv[])
{
	int forked = 0;
	FILE* fp;

	sprintf(me.version, "OperBot %s(%s) (Compile: %s %s)",
		PATCHLEVEL, SERIALNUM, __DATE__, __TIME__);

	SetDefaults();

	LoadConf();
	me.j_chanlist = ParseChan(me.join_chan);
	me.o_chanlist = ParseChan(me.op_chan);

	forked=fork();
	if (forked) {
		fp = fopen(PIDFILE, "w");
		fprintf(fp, "%i", forked);
		fclose(fp);
		return 0;
	} 

	while(1) {
		servsock = Connect();
        	if (servsock <= 0) {
                	log("Unable to connect to %s", me.uplink); 
	        } else {
			Register();
			ListenLoop();
		}
		log("Reconnecting to the server in %d seconds", me.r_time);
		sleep(me.r_time);
	}
	return 0;
}
