/********************************************
* sock.c - Main socket routines
*
* CVS $Id: sock.c,v 1.6 2002/09/24 23:54:32 wcampbel Exp $
********************************************/

#include "oper.h"

fd_set readfds, nullfds;

static int Server_receiveFrom(int, char *);
static void Service_processPacket(char *);

int Connect()
{
        struct hostent *hp;
        struct sockaddr_in sa;
        int s;
	char* host = me.uplink;
	int port = me.port;
	struct in_addr * in;

        if ((s = socket(AF_INET, SOCK_STREAM, 0)) < 0)
                return (-1);

	if (me.use_vhost) {
		bzero(&sa, sizeof(sa));
		sa.sin_family = AF_INET;
		if ((hp = gethostbyname (me.vhost)) == NULL) {
			return (-1);
		}
		in = (struct in_addr *) (hp->h_addr_list[0]);
		sa.sin_addr.s_addr = in->s_addr;
		sa.sin_port = 0;
		if (bind(s, (struct sockaddr *) &sa, sizeof(sa)) < 0) {
			close(s);
			return (-1);
		}
	}

        if ((hp = gethostbyname (host)) == NULL) {
                return (-1);
        }

        bzero(&sa, sizeof(sa));
        sa.sin_family = AF_INET;
        sa.sin_port = htons (port);
    bcopy(hp->h_addr, (char *) &sa.sin_addr, hp->h_length);

        if (connect (s, (struct sockaddr *) &sa, sizeof (sa)) < 0) {
                close (s);
                return (-1);
        }

	return s;
}

void ListenLoop()
{
        int SelectResult;
        struct timeval TimeOut;
        static char buf[BUFSIZE + 1];

        while (1)
        {
                memset(buf, '\0', BUFSIZE + 1);
                FD_ZERO(&readfds);
                TimeOut.tv_sec = 500;
                TimeOut.tv_usec = 0L;
                FD_SET(servsock, &readfds);
                if ((SelectResult = select(FD_SETSIZE, &readfds, &nullfds,
                        &nullfds, &TimeOut)) > 0)
                {
                        if (!Server_receiveFrom(servsock, buf))
                        {
                                log("Lost connection to server.");
                                return;
                        }
                        Service_processPacket(buf);
                }
                else
                {
                        /* select returns 0 when the TimeOut is hit */
                        if (SelectResult == 0)
                        {
                                /* simply a timeout, needed for chk() */
                        }
                        else if ((SelectResult == -1) && (errno == EINTR))
                        {
                                /* Interrupted system call, we got a signal */
                        }
                        else
                        {
                                /* select returned -1, an error condition of
                                ** some kind (we don't care what) occurred.
                                */
                                log("Lost connection to server.");
                                return;
                        }
                }
        }
}

/* These two functions were originally lifted from oswald's NoteServ */
static int Server_receiveFrom(int fd, char *buffer)
{
    /* This mustn't be BUFSIZE!!! */
    /* unless buffer is BUFSIZE + 1 */
    int n = read(fd, buffer, BUFSIZE);
    buffer[n] = '\0';
    return n;
}

static void Service_processPacket(char *buffer)
{   
    char *ptr;
    char buffer2[BUFSIZE * 2];
    static char tmp[BUFSIZE * 2 + 1];

    while ((ptr = strchr(buffer, '\n')))
    {   
        *ptr = '\0';
        if (*(ptr - 1) == '\r')
            *(ptr - 1) = '\0';
        snprintf(buffer2, (BUFSIZE * 2), "%s%s", tmp, buffer);
        *tmp = '\0';
        Parse(buffer2);
        buffer = ptr + 1;
    }
    if (*buffer)
    {
        strncpy(tmp, buffer, (BUFSIZE * 2) - strlen(tmp));
        tmp[BUFSIZE * 2] = '\0';
    }
}

